# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_strings_rule-ModifyAfterValidation"
    languages:
      - "kotlin"
    message: |
      CERT: IDS11-J. Perform any string modifications before validation
    metadata:
      shortDescription: "Collapse of data into unsafe value"
      category: "security"
      cwe: "CWE-182"
      confidence: "HIGH"
      owasp:
        - "A1:2017-Injection"
        - "A03:2021-Injection"
      security-severity: "MEDIUM"
    severity: "WARNING"

    patterns:
      - pattern-inside: |
          $PATTERN = Pattern.compile(...)
          ...
      - pattern-inside: |
          $PATTERN.matcher($VAR)
          ...
      - pattern-either:
          - pattern: |
              $VAR + $OTHER
          - patterns:
              - pattern: |
                  $VAR.$METHOD(...)
              - metavariable-regex:
                  metavariable: "$METHOD"
                  regex: "(replace|replaceAll|replaceFirst|concat)"
